//
//  POITableViewCell.m
//  TestTravelController
//
//  Created by Apple on 17/3/21.
//  Copyright © 2017年 手握日月摘星辰，世间无我这般人. All rights reserved.
//

#import "POITableViewCell.h"

#import "TrafficTableViewCell.h"

#import "UIImageView+WebCache.h"

#import "LogicDefine.h"

@interface POITableViewCell ()<UITableViewDataSource,UITableViewDelegate>

#pragma mark－－－－－－－－－－视图部分
/**原点**/
@property(strong,nonatomic) UIImageView *circleImageview;

/**poiName**/
@property(strong,nonatomic) UILabel *poiNameLabel;

/*poiCover**/
@property(strong,nonatomic) UIImageView *poiImageView;

/**poiEditImage**/
@property(strong,nonatomic) UIImageView *remindImageView;

/**poiCommentBottomView**/
@property(strong,nonatomic) UIView *commentBottomView;

/**poiCommenterHeadView**/
@property(strong,nonatomic) UIImageView *commenterHeadImageView;

/**poiComment**/
@property(strong,nonatomic) UILabel *commentLabel;

/**poiTrafficView**/
@property(strong,nonatomic) UITableView *hyTableview;

//@property(strong,nonatomic) TrafficView *hyTrafficView;


#pragma mark－－－－－－－－－－数据部分
@property(strong,nonatomic) NSArray *dataSource;

@end


@implementation POITableViewCell

-(instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    if (self=[super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        self.selectionStyle=UITableViewCellSelectionStyleNone;
        self.userInteractionEnabled=YES;
        [self createMainView];
    }
    return self;
}


#pragma mark－－－－－－－－－－－－－－－创建视图－－－－－－－－－－
-(void)createMainView
{
    //时间
    self.timeLabel=[[UILabel alloc]initWithFrame:CGRectMake(0,0,50,40)];
    self.timeLabel.font=[UIFont systemFontOfSize:14];
    self.timeLabel.textColor=[UIColor lightGrayColor];
    self.timeLabel.text=@"08:30";
    [self.contentView addSubview:self.timeLabel];
    
    //点标记
    self.circleImageview=[[UIImageView alloc]initWithFrame:CGRectMake(47,17,6,6)];
    self.circleImageview.layer.cornerRadius=3;
    self.circleImageview.layer.masksToBounds=YES;
    self.circleImageview.backgroundColor=[UIColor lightGrayColor];
    [self.contentView addSubview:self.circleImageview];
    
    //名称
    self.poiNameLabel=[[UILabel alloc]initWithFrame:CGRectMake(60,0,UIScreen_Width-60,40)];
    self.poiNameLabel.text=@"长江一号";
    self.poiNameLabel.textColor=[UIColor lightGrayColor];
    self.poiNameLabel.textAlignment=NSTextAlignmentLeft;
    [self.poiNameLabel setFont:[UIFont systemFontOfSize:14]];
    [self.contentView addSubview:self.poiNameLabel];
    
    //poiImageView
    self.poiImageView=[[UIImageView alloc]initWithFrame:CGRectMake(60,40,UIScreen_Width-80,(UIScreen_Width-80)*0.62)];
    [self.poiImageView sd_setImageWithURL:[NSURL URLWithString:@"https://imgsa.baidu.com/baike/c0%3Dbaike80%2C5%2C5%2C80%2C26/sign=8155fc72932397ddc274905638ebd9d2/d31b0ef41bd5ad6e39a9a17f83cb39dbb7fd3cd7.jpg"] placeholderImage:[UIImage imageNamed:@" "]];
    self.poiImageView.layer.cornerRadius=5;
    self.poiImageView.layer.masksToBounds=YES;
    self.poiImageView.userInteractionEnabled=YES;
    [self.contentView addSubview:self.poiImageView];
    
    CGFloat poiImageViewGeight=CGRectGetMaxY(self.poiImageView.frame);
    //底部视图
    self.commentBottomView=[[UIView alloc]initWithFrame:CGRectMake(60,poiImageViewGeight,UIScreen_Width-80,60)];
    self.commentBottomView.userInteractionEnabled=YES;
    self.commentBottomView.backgroundColor=[UIColor whiteColor];
    [self.contentView addSubview:self.commentBottomView];
    
    //头像
    self.commenterHeadImageView=[[UIImageView alloc]initWithFrame:CGRectMake(0,10,40,40)];
    [self.commenterHeadImageView sd_setImageWithURL:[NSURL URLWithString:@"https://timgsa.baidu.com/timg?image&quality=80&size=b9999_10000&sec=1490094933669&di=8584cca63587e3baac2f77924ba43f51&imgtype=0&src=http%3A%2F%2Fcdn.duitang.com%2Fuploads%2Fitem%2F201601%2F07%2F20160107180640_mTXiF.jpeg"] placeholderImage:[UIImage imageNamed:@""]];
    self.commenterHeadImageView.layer.cornerRadius=20;
    self.commenterHeadImageView.layer.masksToBounds=YES;
    self.commenterHeadImageView.userInteractionEnabled=YES;
    [self.commentBottomView addSubview:self.commenterHeadImageView];
    
    //评论
    self.commentLabel=[[UILabel alloc]initWithFrame:CGRectMake(50,10,UIScreen_Width-130,40)];
    self.commentLabel.text=@"手握日月摘星辰,世间无我这般人";
    self.commentLabel.textColor=[UIColor lightGrayColor];
    self.commentLabel.font=[UIFont systemFontOfSize:14];
    [self.commentBottomView addSubview:self.commentLabel];
    
    //直线
    self.lineView=[[UIView alloc]initWithFrame:CGRectMake(50,0,1,100+(UIScreen_Width-80*0.62))];
    self.lineView.backgroundColor=[UIColor lightGrayColor];
    [self.contentView addSubview:self.lineView];
    
    self.hyTableview=[[UITableView alloc]initWithFrame:CGRectMake(60,0,UIScreen_Width-60,0) style:UITableViewStylePlain];
    self.hyTableview.delegate=self;
    self.hyTableview.dataSource=self;
    self.hyTableview.scrollEnabled=NO;
    [self.contentView addSubview:self.hyTableview];
}


#pragma mark－－－－－－－－－－－－－－－请求数据－－－－－－－－－－
-(void)requestPoiData:(PoiModel*)poiModel
{
    self.poiNameLabel.text=poiModel.poiName;
    if ([poiModel.poiCover isEqualToString:@" "]) {//是出发点的数据
        self.poiImageView.frame=CGRectMake(60,40,UIScreen_Width-80,0);
        self.commentBottomView.frame=CGRectMake(60,40,UIScreen_Width-80,0);
        self.commenterHeadImageView.frame=CGRectMake(0,0,0,0);
        self.commentLabel.frame=CGRectMake(0,0,0,0);
        if (poiModel.poiTrafficArray.count>0) {
            self.hyTableview.frame=CGRectMake(60,40,UIScreen_Width-60,40*poiModel.poiTrafficArray.count);
            self.dataSource=poiModel.poiTrafficArray;
            [self.hyTableview reloadData];
        }
    }else{
        self.poiImageView.frame=CGRectMake(60,40,UIScreen_Width-80,(UIScreen_Width-80)*0.62);
        self.commentBottomView.frame=CGRectMake(0,10,40,40);
        self.commenterHeadImageView.frame=CGRectMake(0,10,40,40);
        self.commentLabel.frame=CGRectMake(50,10,UIScreen_Width-130,40);
        [self.poiImageView sd_setImageWithURL:[NSURL URLWithString:poiModel.poiCover] placeholderImage:[UIImage imageNamed:@" "]];
    
        [self.commenterHeadImageView sd_setImageWithURL:[NSURL URLWithString:[poiModel.poiCommentDic objectForKey:@"Cover"]] placeholderImage:[UIImage imageNamed:@" "]];
        self.commentLabel.text=[poiModel.poiCommentDic objectForKey:@"Title"];
        if (poiModel.poiTrafficArray.count>0) {
            CGFloat bottomViewHeight=CGRectGetMaxY(self.commentBottomView.frame);
            self.hyTableview.frame=CGRectMake(60,bottomViewHeight,UIScreen_Width-80,40*poiModel.poiTrafficArray.count);
            self.dataSource=poiModel.poiTrafficArray;
            [self.hyTableview reloadData];
        }
    }
    //最终线的长度＝标题(40)+图片＋评论＋交通+子景点的高度
    self.lineView.frame=CGRectMake(50,0,1,40+self.poiImageView.frame.size.height+self.commentBottomView.frame.size.height+40*poiModel.poiTrafficArray.count);
}

#pragma mark－－－－－－－－－－－－－－－设置代理－－－－－－－－－－
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.dataSource.count;
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *cellId=@"testTrafficCell";
    TrafficTableViewCell *cell=[tableView dequeueReusableCellWithIdentifier:cellId];
    if (!cell) {
        cell=[[TrafficTableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellId];
    }
    self.hyTableview.separatorStyle=UITableViewCellSeparatorStyleNone;
    [cell requestTraffic:[self.dataSource objectAtIndex:indexPath.row]];
    return cell;
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 40;
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSLog(@"***********************************");
}


#pragma mark－－－－－－－－－－－－－－－用户交互－－－－－－－－－－



- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

@end
