//
//  ShowTrafficDetailView.m
//  TestTravelController
//
//  Created by Apple on 17/3/22.
//  Copyright © 2017年 手握日月摘星辰，世间无我这般人. All rights reserved.
//

#import "ShowTrafficDetailView.h"

@interface ShowTrafficDetailView ()

#pragma mark－－－－－－－－－－视图
/**返回按钮**/
@property(strong,nonatomic) UIButton *backBtn;

/**绘制直线**/
@property(strong,nonatomic) UIBezierPath  *path;

/**标题**/
@property(strong,nonatomic) UILabel *titleLabel;

@end

@implementation ShowTrafficDetailView

-(instancetype)initWithFrame:(CGRect)frame
{
    if (self=[super initWithFrame:frame]) {
        self.backgroundColor=[UIColor whiteColor];
        
        [self createMainView];
    }
    return self;
}



#pragma mark－－－－－－－－－－－－－－－创建视图－－－－－－－－－－
-(void)createMainView
{
    //标题
    self.titleLabel=[[UILabel alloc]initWithFrame:CGRectMake(0,34,UIScreen_Width,30)];
    self.titleLabel.textAlignment=NSTextAlignmentCenter;
    self.titleLabel.font=[UIFont systemFontOfSize:20];
    self.titleLabel.textColor=[UIColor lightGrayColor];
    self.titleLabel.text=@"交通详情";
    [self addSubview:self.titleLabel];
    
    //返回按钮
    self.backBtn=[UIButton buttonWithType:UIButtonTypeCustom];
    self.backBtn.frame=CGRectMake(UIScreen_Width-40,64,40,40);
    [self.backBtn setImage:[UIImage imageNamed:@"返回.png"] forState:UIControlStateNormal];
    [self.backBtn addTarget:self action:@selector(backTravel) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:self.backBtn];
}
-(void)drawLine:(CGFloat)orignY
{
    //动态的绘制一条线
    self.path=[UIBezierPath bezierPath];
    [self.path moveToPoint:CGPointMake(60,64+orignY)];
    [self.path addLineToPoint:CGPointMake(60,UIScreen_Height-orignY)];
    
    CAShapeLayer *pathLayer=[CAShapeLayer layer];
    pathLayer.frame=self.bounds;
    pathLayer.path=self.path.CGPath;
    pathLayer.strokeColor = [[UIColor lightGrayColor] CGColor];
    pathLayer.fillColor = nil;
    pathLayer.lineWidth = 1.0f;
    pathLayer.lineJoin = kCALineJoinBevel;
    [self.layer addSublayer:pathLayer];
    
    //设置动画
    CABasicAnimation *pathAnimation = [CABasicAnimation animationWithKeyPath:@"strokeEnd"];
    pathAnimation = [CABasicAnimation animationWithKeyPath:@"strokeEnd"];
    pathAnimation.duration = 2.0;
    pathAnimation.timingFunction=[CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseIn];
    //其实是给线条绘制颜色的
    pathAnimation.fromValue = [NSNumber numberWithFloat:0.0f];
    pathAnimation.toValue = [NSNumber numberWithFloat:1.0f];
    [pathLayer addAnimation:pathAnimation forKey:@"strokeEnd"];
}



#pragma mark－－－－－－－－－－－－－－－请求数据－－－－－－－－－－
-(void)requestTrafficInfo:(NSArray *)trafficArray
{
    CGFloat viewHeight=(UIScreen_Height-64)/trafficArray.count;
    [self drawLine:viewHeight/2];
    [UIView animateWithDuration:3 animations:^{
        for (int i=0;i<trafficArray.count;i++) {
            UIImageView *circleImageView=[[UIImageView alloc]initWithFrame:CGRectMake(57,64+viewHeight*i+(viewHeight/2-3),6,6)];
            circleImageView.backgroundColor=[UIColor lightGrayColor];
            circleImageView.layer.cornerRadius=3;
            circleImageView.layer.masksToBounds=YES;
            circleImageView.clipsToBounds=YES;
            [self addSubview:circleImageView];
            
            UILabel *label=[[UILabel alloc]initWithFrame:CGRectMake(80,(viewHeight*i)+10+64,UIScreen_Width-70,viewHeight-20)];
            label.textColor=[UIColor lightGrayColor];
            label.font=[UIFont systemFontOfSize:14];
            label.text=[[trafficArray objectAtIndex:i]objectForKey:@"Name"];
            [self addSubview:label];
        }
    }];
}

#pragma mark－－－－－－－－－－－－－－－用户交互－－－－－－－－－－
//点击返回按钮
-(void)backTravel
{
    [self.delegate hiddenView];
}

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

@end
