//
//  TrafficHubTableViewCell.m
//  TestTravelController
//
//  Created by Apple on 17/3/21.
//  Copyright © 2017年 手握日月摘星辰，世间无我这般人. All rights reserved.
//

#import "TrafficHubTableViewCell.h"
#import "TrafficTableViewCell.h"

@interface TrafficHubTableViewCell ()<UITableViewDelegate,UITableViewDataSource>

#pragma mark－－－－－－－－－－视图

/**竖线**/
@property(strong,nonatomic) UIView *lineView;

/**点标记**/
@property(strong,nonatomic) UIImageView *circleImageview;

/**时间**/
@property(strong,nonatomic) UILabel *timeLabel;

/**底部视图**/
@property(strong,nonatomic) UIView *bottomView;

/**trafficHubName**/
@property(strong,nonatomic) UILabel *trafficHubNameLabel;

/**trafficHubWeather**/
@property(strong,nonatomic) UIImageView *trafficHubWeather;

/**trafficHubNum**/
@property(strong,nonatomic) UILabel *trafficHubNumLabel;

/**trafficHubPrice**/
@property(strong,nonatomic) UILabel *trafficHubPriceLabel;

/**trafficHubTraffic**/
@property(strong,nonatomic) UITableView *hyTableview;
//@property(strong,nonatomic) TrafficView *hyTrafficView;

#pragma mark－－－－－－－－－－数据部分
@property(strong,nonatomic) NSArray *dataSource;

@end


@implementation TrafficHubTableViewCell

-(instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    if (self=[super initWithStyle:style reuseIdentifier:reuseIdentifier]) {
        [self createMainView];
    }
    return self;
}


#pragma mark－－－－－－－－－－－－－－－创建视图－－－－－－－－－－
-(void)createMainView
{
    //时间
    self.timeLabel=[[UILabel alloc]initWithFrame:CGRectMake(0,0,50,40)];
    self.timeLabel.font=[UIFont systemFontOfSize:14];
    self.timeLabel.textColor=[UIColor lightGrayColor];
    self.timeLabel.text=@"08:30";
    [self.contentView addSubview:self.timeLabel];
    
    //点标记
    self.circleImageview=[[UIImageView alloc]initWithFrame:CGRectMake(47,17,6,6)];
    self.circleImageview.layer.cornerRadius=3;
    self.circleImageview.layer.masksToBounds=YES;
    self.circleImageview.backgroundColor=[UIColor lightGrayColor];
    [self.contentView addSubview:self.circleImageview];

    //底部视图
    self.bottomView=[[UIView alloc]initWithFrame:CGRectMake(60,10,UIScreen_Width-70,40)];
    self.bottomView.layer.borderWidth=0.5;
    self.bottomView.layer.cornerRadius=5;
    self.bottomView.backgroundColor=[UIColor whiteColor];
    self.bottomView.layer.borderColor=[UIColor lightGrayColor].CGColor;
    [self.contentView addSubview:self.bottomView];
    
    //名称
    self.trafficHubNameLabel=[[UILabel alloc]initWithFrame:CGRectMake(0,0,70,40)];
    self.trafficHubNameLabel.textColor=[UIColor lightGrayColor];
    self.trafficHubNameLabel.font=[UIFont systemFontOfSize:14];
    [self.bottomView addSubview:self.trafficHubNameLabel];
    
    //天气
    self.trafficHubWeather=[[UIImageView alloc]initWithFrame:CGRectMake(70,10,20,20)];
    self.trafficHubWeather.image=[UIImage imageNamed:@"icon-地铁@2x.png"];
    self.trafficHubWeather.contentMode=UIViewContentModeScaleAspectFit;
    [self.bottomView addSubview:self.trafficHubWeather];
    
    //班次
    self.trafficHubNumLabel=[[UILabel alloc]initWithFrame:CGRectMake(140,0,50,40)];
    self.trafficHubNumLabel.font=[UIFont systemFontOfSize:14];
    self.trafficHubNumLabel.textColor=[UIColor lightGrayColor];
    [self.bottomView addSubview:self.trafficHubNumLabel];
    
    //价格
    self.trafficHubPriceLabel=[[UILabel alloc]initWithFrame:CGRectMake(200,0,50,40)];
    self.trafficHubPriceLabel.textColor=[UIColor lightGrayColor];
    self.trafficHubPriceLabel.font=[UIFont systemFontOfSize:14];
    [self.bottomView addSubview:self.trafficHubPriceLabel];
    
    //直线
    self.lineView=[[UIView alloc]initWithFrame:CGRectMake(50,0,1,60)];
    self.lineView.backgroundColor=[UIColor lightGrayColor];
    [self.contentView addSubview:self.lineView];
    
    self.hyTableview=[[UITableView alloc]initWithFrame:CGRectMake(60,0,UIScreen_Width-60,0) style:UITableViewStylePlain];
    self.hyTableview.delegate=self;
    self.hyTableview.dataSource=self;
    self.hyTableview.scrollEnabled=NO;
    [self.contentView addSubview:self.hyTableview];
}

-(void)requestTrafficHubModel:(TrafficHubModel *)hubModel
{
    self.trafficHubNameLabel.text=hubModel.trafficHubName;
    self.trafficHubNumLabel.text=hubModel.trafficHubNo;
    self.trafficHubPriceLabel.text=hubModel.trafficHubPrice;
    if (hubModel.trafficArray.count>0) {
        self.hyTableview.frame=CGRectMake(60,60,UIScreen_Width-60,40*hubModel.trafficArray.count);
        self.dataSource=hubModel.trafficArray;
        [self.hyTableview reloadData];
    }
    //最终线的长度＝hub表视图+交通视图高度
    self.lineView.frame=CGRectMake(50,0,1,40*hubModel.trafficArray.count+60);
}

#pragma mark－－－－－－－－－－－－－－－设置代理－－－－－－－－－－
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.dataSource.count;
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *cellId=@"testTrafficCell";
    TrafficTableViewCell *cell=[tableView dequeueReusableCellWithIdentifier:cellId];
    if (!cell) {
        cell=[[TrafficTableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellId];
    }
    self.hyTableview.separatorStyle=UITableViewCellSeparatorStyleNone;
    [cell requestTraffic:[self.dataSource objectAtIndex:indexPath.row]];
    return cell;
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSInteger height=40;
    TrafficModel *tempModel=[self.dataSource objectAtIndex:indexPath.row];
    if (tempModel.hasSelected) {
        height+=tempModel.trafficViaStops.count*30;
    }
    return height;
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    
}


//计算文字的长度
-(CGSize)calculationTextLength:(NSString*)text textFont:(CGFloat)font
{
    NSDictionary *titleDic=@{NSFontAttributeName:[UIFont systemFontOfSize:font]};
    CGSize title=CGSizeMake(UIScreen_Width,10000);
    CGSize textSize=[text boundingRectWithSize:title options:NSStringDrawingTruncatesLastVisibleLine | NSStringDrawingUsesLineFragmentOrigin | NSStringDrawingUsesFontLeading attributes:titleDic context:nil].size;
    return textSize;
}




- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

@end
