//
//  TravelViewController.m
//  TestTravelController
//
//  Created by Apple on 17/3/21.
//  Copyright © 2017年 手握日月摘星辰，世间无我这般人. All rights reserved.
//

#import "TravelViewController.h"

#import "POITableViewCell.h"
#import "TrafficHubTableViewCell.h"

#import "LogicDefine.h"

@interface TravelViewController ()<UITableViewDelegate,UITableViewDataSource>

#pragma mark－－－－－－－－－－数据部分
@property(strong,nonatomic) UITableView *hyTableview;


#pragma mark－－－－－－－－－－数据部分
@property(strong,nonatomic) NSDictionary *dataDic;

/**数据数组**/
@property(strong,nonatomic) NSMutableArray *travelArray;

@end

@implementation TravelViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor=[UIColor whiteColor];
    self.title=@"行程界面";
    self.travelArray=[NSMutableArray arrayWithCapacity:0];
    
    
    //创建主视图
    [self createMainView];
    
    [self requestTravelDic];
}


#pragma mark－－－－－－－－－－－－－－－创建视图
-(void)createMainView
{
    self.hyTableview=[[UITableView alloc]initWithFrame:CGRectMake(0,0,UIScreen_Width,UIScreen_Height) style:UITableViewStyleGrouped];
    self.hyTableview.delegate=self;
    self.hyTableview.dataSource=self;
    self.hyTableview.showsVerticalScrollIndicator=NO;
    self.hyTableview.showsHorizontalScrollIndicator=NO;
    [self.view addSubview:self.hyTableview];
}


#pragma mark－－－－－－－－－－－－－－－请求数据

-(void)requestTravelDic
{
    NSDictionary *firstDic=@{ @"Type":@"1",@"Distance":@"357",@"Duration":@"306"};
    
    NSDictionary *secondDic=@{ @"Type":@"3",@"Distance":@"2118",@"Duration":@"292",@"Name":@"地铁1号线(四惠东--苹果园)",@"Entrance":@"A西北口",@"Departure":@"天安门东",@"Arrival":@"西单",@"StartTime":@"05:05",@"EndTime":@"2315",@"ViaNum":@"1",@"ViaStops": @[@{@"Name": @"天安门西"}]};
    
    NSDictionary *thirdDic=@{@"Type":@"1",@"Distance": @"296",@"Duration": @"253"};
    
    NSDictionary *fourThDic=@{@"Type":@"3",@"Distance":@"4598",@"Duration":@"528",@"Name":@"地铁4号线大兴线(安河桥北--天宫院)",@"Exit":@"C东南口",@"Departure": @"西单",@"Arrival": @"北京南站",@"StartTime": @"05:05",@"EndTime": @"2315",@"ViaNum": @"3",@"ViaStops": @[@{@"Name": @"宣武门"},@{@"Name": @"菜市口"},@{@"Name": @"陶然亭"}]};
    
    NSDictionary *fifthDic=@{@"Type":@"4",@"Distance": @"1312000",@"Duration": @17340,@"Name": @"G1(北京南-上海虹桥)",@"TripNo": @"G1",@"Departure": @"北京南",@"StartTime": @"0900",@"Arrival": @"上海虹桥",@"EndTime": @"1349",@"Code": @"二等座",@"Cost": @"553"};
    
    NSDictionary *sixThDic=@{ @"Type": @"1",@"Distance":@"242",@"Duration":@"207"};
    
    NSDictionary *seventDic=@{@"Type":@"3",@"Distance":@"20975",@"Duration": @1875,@"Name": @"地铁2号线(徐泾东--广兰路)",@"Exit": @"6号口",@"Departure": @"虹桥火车站",@"Arrival": @"陆家嘴",@"StartTime":@"",@"EndTime": @"",@"ViaNum": @11,@"ViaStops": @[@{@"Name": @"虹桥2号航站楼"},@{@"Name": @"淞虹路"},@{
                                                                                                                                                                                @"Name": @"北新泾"
                                                                                                                                                                                                                                          },
                                                                                                                                                                                                                                      @{
                                                                                                                                                                                                                                          @"Name": @"威宁路"
                                                                                                                                                                                                                                          },
                                                                                                                                                                                                                                      @{
                                                                                                                                                                                                                                          @"Name": @"娄山关路"
                                                                                                                                                                                                                                          },
                                                                                                                                                                                                                                      @{
                                                                                                                                                                                                                                          @"Name": @"中山公园"
                                                                                                                                                                                                                                          },
                                                                                                                                                                                                                                      @{
                                                                                                                                                                                                                                          @"Name": @"江苏路"
                                                                                                                                                                                                                                          },
                                                                                                                                                                                                                                      @{
                                                                                                                                                                                                                                          @"Name": @"静安寺"
                                                                                                                                                                                                                                          },
                                                                                                                                                                                                                                      @{
                                                                                                                                                                                                                                          @"Name": @"南京西路"
                                                                                                                                                                                                                                          },
                                                                                                                                                                                                                @{
                                                                                                                                                                                                                                          @"Name": @"人民广场"
                                                                                                                                                                                                                                          },
                                                                                                                                                                                                                                      @{
                                                                                                                                                                                                                                          @"Name": @"南京东路"
                                                                                                                                                            }
                                                                                                                                                                                                                        ]};
    
    NSArray *trafficTempArray=[NSArray arrayWithObjects:firstDic,secondDic,thirdDic,fourThDic,fifthDic,sixThDic,seventDic,nil];
    
    
    NSDictionary *trafficDic=@{@"TaxiCost":@"3756.48115",@"Latitude":@"31.2329",@"Longitude":@"121.501525",@"Cost":@"566",@"Distance":@"1367274",@"Duration":@"24180",@"Segments":trafficTempArray};
    
    NSDictionary *routeDic=@{@"PoiType":@"2",@"PoiId":@"1",@"Name": @"东方明珠",@"Describe": @"东方明珠的描述",@"Latitude":@"31.2329",@"Longitude": @"121.501525",@"StartTime": @"09:00",@"EndTime": @"10:00",@"Cover": @"https://imgsa.baidu.com/baike/c0%3Dbaike80%2C5%2C5%2C80%2C26/sign=8155fc72932397ddc274905638ebd9d2/d31b0ef41bd5ad6e39a9a17f83cb39dbb7fd3cd7.jpg",@"LikeCount":@"11",@"Comment": @{@"CommentId":@"1",@"Title": @"对对对，我也去过，是挺不错了，还会再去。",@"Cover": @"https://imgsa.baidu.com/baike/c0%3Dbaike80%2C5%2C5%2C80%2C26/sign=8155fc72932397ddc274905638ebd9d2/d31b0ef41bd5ad6e39a9a17f83cb39dbb7fd3cd7.jpg",@"LikeCount": @"10"},@"Alternative": @[@{@"PoiType":@"2",@"PoiId":@"1",@"Name": @"东方明珠1",@"Describe": @"东方明珠1的描述",@"Latitude":@"31.2329",@"Longitude": @"31.2329",@"StartTime": @"09:00",@"EndTime": @"10:00",@"Cover": @"https://imgsa.baidu.com/baike/c0%3Dbaike80%2C5%2C5%2C80%2C26/sign=8155fc72932397ddc274905638ebd9d2/d31b0ef41bd5ad6e39a9a17f83cb39dbb7fd3cd7.jpg",@"LikeCount":@"11",@"Comment": @{@"CommentId":@"1",@"Title": @"对对对，我也去过，是挺不错了，还会再去。",@"Cover": @"https://imgsa.baidu.com/baike/c0%3Dbaike80%2C5%2C5%2C80%2C26/sign=8155fc72932397ddc274905638ebd9d2/d31b0ef41bd5ad6e39a9a17f83cb39dbb7fd3cd7.jpg",@"LikeCount": @"10"}},@{@"PoiType":@"2",@"PoiId":@"1",@"Name": @"东方明珠2",@"Describe": @"东方明珠2的描述",@"Latitude": @"31.2329",@"Longitude": @"121.501525",@"StartTime": @"09:00",@"EndTime": @"10:00",@"Cover": @"https://imgsa.baidu.com/baike/c0%3Dbaike80%2C5%2C5%2C80%2C26/sign=8155fc72932397ddc274905638ebd9d2/d31b0ef41bd5ad6e39a9a17f83cb39dbb7fd3cd7.jpg",@"LikeCount": @"11",@"Comment": @{@"CommentId": @"1",@"Title": @"对对对，我也去过，是挺不错了，还会再去。",@"Cover": @"https://imgsa.baidu.com/baike/c0%3Dbaike80%2C5%2C5%2C80%2C26/sign=8155fc72932397ddc274905638ebd9d2/d31b0ef41bd5ad6e39a9a17f83cb39dbb7fd3cd7.jpg",@"LikeCount": @"10"}}]};
    
    NSArray *tempRouteArray=[NSArray arrayWithObjects:routeDic,nil];
    
    
    
    //模拟后台的数据
    NSDictionary *backDic=@{@"Departure":@"天安门广场",@"Latitude":@"39.907923",@"Longitude":@"116.397483",@"Date":@"2017-03-21",@"Time":@"08:10",@"Traffic":trafficDic,@"Route":tempRouteArray};
    
    
    
    NSDictionary *startDic=@{@"PoiType":@" ",@"PoiId":@" ",@"PoiName":[backDic objectForKey:@"Departure"],@"poiDescrbe":@" ",@"Latitude":[backDic objectForKey:@"Latitude"],@"Longitude":[backDic objectForKey:@"Longitude"],@"StartTime":@" ",@"EndTime":@" ",@"Cover":@" ",@"Comment":@" ",@"Alternative":@" "};
    
    //景点信息
    PoiModel *firstPoiModel=[[PoiModel alloc]initWithDic:startDic];
    
    //景点的交通信息
    NSDictionary *lastPoiTraffic=[backDic objectForKey:@"Traffic"];
    NSMutableArray *lastPoiTrafficArray=[NSMutableArray arrayWithArray:[lastPoiTraffic objectForKey:@"Segments"]];
    
    NSMutableArray *tempLastPoiTraficArray=[NSMutableArray arrayWithCapacity:0];
    NSMutableArray *surplusArray=[NSMutableArray arrayWithCapacity:0];
    NSString *lastTrafficName=firstPoiModel.poiName;
    for (int i=0;i<lastPoiTrafficArray.count;i++) {
        NSDictionary *currentTrafficDic=[lastPoiTrafficArray objectAtIndex:i];
        NSString *trafficType=[currentTrafficDic objectForKey:@"Type"];
        if ([trafficType integerValue]==4) {//是交通hub，需要拆分数据
            for (int j=i;j<lastPoiTrafficArray.count;j++) {
                [surplusArray addObject:[lastPoiTrafficArray objectAtIndex:j]];
            }
            break;
        }else{//正常的数据，直接插入数组
            if ([trafficType integerValue]==1) {//步行
                if (i==0) {
                    lastTrafficName=firstPoiModel.poiName;
                }
                
                TrafficModel *lastTrafficModel=[tempLastPoiTraficArray lastObject];
                if ([lastTrafficModel.trafficName containsString:lastTrafficName]) {//删除重复的点
                    [tempLastPoiTraficArray removeLastObject];
                }
                NSDictionary *tempTrafficDic=@{@"Type":[currentTrafficDic objectForKey:@"Type"],@"TrafficDisNum":[currentTrafficDic objectForKey:@"Distance"],@"Duration":[currentTrafficDic objectForKey:@"Duration"],@"TrafficName":lastTrafficName,@"StartTime":@" ",@"EndTime":@" ",@"ViaStops":@" "};
                TrafficModel *tempModel=[[TrafficModel alloc]initWithDic:tempTrafficDic];
                [tempLastPoiTraficArray addObject:tempModel];
            }else if ([trafficType integerValue]==2){//公交
                
            }else{//地铁(要分为两段，上车的地方和下车的地方)
                //上车
                NSString *getOn=[NSString stringWithFormat:@"%@(上车)",[currentTrafficDic objectForKey:@"Departure"]];
                
                NSMutableArray *tempViaStop=[NSMutableArray arrayWithCapacity:0];
                [tempViaStop addObject:@{@"Name":getOn}];
                [tempViaStop addObjectsFromArray:[currentTrafficDic objectForKey:@"ViaStops"]];
                [tempViaStop addObject:@{@"Name":[NSString stringWithFormat:@"%@(下车)",[currentTrafficDic objectForKey:@"Arrival"]]}];
                
                NSDictionary *tempStartTrafficDic=@{@"Type":[currentTrafficDic objectForKey:@"Type"],@"TrafficDisNum":[currentTrafficDic objectForKey:@"Name"],@"Duration":[currentTrafficDic objectForKey:@"Duration"],@"TrafficName":getOn,@"StartTime":[currentTrafficDic objectForKey:@"StartTime"],@"EndTime":[currentTrafficDic objectForKey:@"EndTime"],@"ViaStops":tempViaStop};
                TrafficModel *tempStartModel=[[TrafficModel alloc]initWithDic:tempStartTrafficDic];
                [tempLastPoiTraficArray addObject:tempStartModel];
                
                //下车
                NSString *goOut=[NSString stringWithFormat:@"%@(下车)",[currentTrafficDic objectForKey:@"Arrival"]];
                NSDictionary *tempArriveTrafficDic=@{@"Type":@"5",@"TrafficDisNum":@" ",@"Duration":[currentTrafficDic objectForKey:@"Duration"],@"TrafficName":goOut,@"StartTime":[currentTrafficDic objectForKey:@"StartTime"],@"EndTime":[currentTrafficDic objectForKey:@"EndTime"],@"ViaStops":@" "};
                TrafficModel *tempArriveModel=[[TrafficModel alloc]initWithDic:tempArriveTrafficDic];
                [tempLastPoiTraficArray addObject:tempArriveModel];
                lastTrafficName=[currentTrafficDic objectForKey:@"Arrival"];
            }
        }
    }
    
    //交通赋值
    if (tempLastPoiTraficArray.count>0) {
        [firstPoiModel requestTrafficArray:tempLastPoiTraficArray];
    }
    [self.travelArray addObject:firstPoiModel];

    
    if (surplusArray.count>0) {//含有跨市的数据
        NSDictionary *hubDic=[surplusArray firstObject];
        NSDictionary *firstHubDic=@{@"HubName":[hubDic objectForKey:@"Departure"],@"HubWeather":@" ",@"TripNo":[hubDic objectForKey:@"TripNo"],@"Cost":[hubDic objectForKey:@"Cost"],@"StartTime":[hubDic objectForKey:@"StartTime"],@"Duration":[hubDic objectForKey:@"Duration"]};
        TrafficHubModel *hubModel=[[TrafficHubModel alloc]initDataDic:firstHubDic];
        [self.travelArray addObject:hubModel];
        
        NSDictionary *secondHubDic=@{@"HubName":[hubDic objectForKey:@"Arrival"],@"HubWeather":@" ",@"TripNo":@" ",@"Cost":@" ",@"StartTime":@" ",@"Duration":@" "};
        
        TrafficHubModel *secondHubModel=[[TrafficHubModel alloc]initDataDic:secondHubDic];
        [self.travelArray addObject:secondHubModel];

        //删除第一个数据
        [surplusArray removeObjectAtIndex:0];
        NSMutableArray *finalTrafficArray=[NSMutableArray arrayWithCapacity:0];
        NSString *lastTrafficName=secondHubModel.trafficHubName;
        for (int i=0;i<surplusArray.count;i++) {
            NSDictionary *currentTrafficDic=[surplusArray objectAtIndex:i];
            NSString *trafficType=[currentTrafficDic objectForKey:@"Type"];
            if ([trafficType integerValue]==1) {//步行
                if (i==0) {
                    lastTrafficName=lastTrafficName;
                }
                NSDictionary *tempTrafficDic=@{@"Type":[currentTrafficDic objectForKey:@"Type"],@"TrafficDisNum":[currentTrafficDic objectForKey:@"Distance"],@"Duration":[currentTrafficDic objectForKey:@"Duration"],@"TrafficName":lastTrafficName,@"StartTime":@" ",@"EndTime":@" ",@"ViaStops":@" "};
                TrafficModel *tempModel=[[TrafficModel alloc]initWithDic:tempTrafficDic];
                [finalTrafficArray addObject:tempModel];
            }else if ([trafficType integerValue]==2){//公交
                
            }else{//地铁
                //上车
                NSString *getOn=[NSString stringWithFormat:@"%@(上车)",[currentTrafficDic objectForKey:@"Departure"]];
                //把出发地目的地也加上去
                NSMutableArray *ViaStops=[NSMutableArray arrayWithCapacity:0];
                [ViaStops addObject:@{@"Name":getOn}];
                [ViaStops addObjectsFromArray:[currentTrafficDic objectForKey:@"ViaStops"]];
                NSDictionary *lastViaDic=@{@"Name":[NSString stringWithFormat:@"%@(下车)",[currentTrafficDic objectForKey:@"Arrival"]]};
                [ViaStops addObject:lastViaDic];
                
                NSDictionary *tempStartTrafficDic=@{@"Type":[currentTrafficDic objectForKey:@"Type"],@"TrafficDisNum":[currentTrafficDic objectForKey:@"Name"],@"Duration":[currentTrafficDic objectForKey:@"Duration"],@"TrafficName":getOn,@"StartTime":[currentTrafficDic objectForKey:@"StartTime"],@"EndTime":[currentTrafficDic objectForKey:@"EndTime"],@"ViaStops":ViaStops};
                TrafficModel *tempStartModel=[[TrafficModel alloc]initWithDic:tempStartTrafficDic];
                [finalTrafficArray addObject:tempStartModel];
                
                //下车
                NSString *goOut=[NSString stringWithFormat:@"%@(下车)",[currentTrafficDic objectForKey:@"Arrival"]];
                NSDictionary *tempArriveTrafficDic=@{@"Type":@"5",@"TrafficDisNum":@" ",@"Duration":[currentTrafficDic objectForKey:@"Duration"],@"TrafficName":goOut,@"StartTime":[currentTrafficDic objectForKey:@"StartTime"],@"EndTime":[currentTrafficDic objectForKey:@"EndTime"],@"ViaStops":@" "};
                TrafficModel *tempArrivalModel=[[TrafficModel alloc]initWithDic:tempArriveTrafficDic];
                [finalTrafficArray addObject:tempArrivalModel];
                lastTrafficName=[currentTrafficDic objectForKey:@"Arrival"];
            }
        }
        [secondHubModel requestTrafficData:finalTrafficArray];
    }
    NSLog(@"最终的数据是%@",self.travelArray);
    TrafficHubModel *testModel=[self.travelArray lastObject];
    
    [self.hyTableview reloadData];
}


#pragma mark－－－－－－－－－－－－－－－设置代理

-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.travelArray.count;
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    self.hyTableview.separatorStyle=UITableViewCellSeparatorStyleNone;
    if ([[self.travelArray objectAtIndex:indexPath.row]isKindOfClass:[PoiModel class]]) {
        static NSString *cellId=@"newPOICell";
        POITableViewCell *cell=[tableView dequeueReusableCellWithIdentifier:cellId];
        if (!cell) {
            cell=[[POITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellId];
        }
        [cell requestPoiData:[self.travelArray objectAtIndex:indexPath.row]];
        return cell;

    }else{
        static NSString *cellId=@"newTrafficHubCell";
        TrafficHubTableViewCell *hubCell=[tableView dequeueReusableCellWithIdentifier:cellId];
        if (!hubCell) {
            hubCell=[[TrafficHubTableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:cellId];
        }
        [hubCell requestTrafficHubModel:[self.travelArray objectAtIndex:indexPath.row]];
        return hubCell;
    }
    return [[UITableViewCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"cell"];
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSInteger finalCount=0;
    if ([[self.travelArray objectAtIndex:indexPath.row]isKindOfClass:[TrafficHubModel class]]) {//交通hub
        TrafficHubModel *tempModel=[self.travelArray objectAtIndex:indexPath.row];
        finalCount=60+tempModel.trafficArray.count*40;
    }else{
        PoiModel *tempModel=[self.travelArray objectAtIndex:indexPath.row];
        if ([tempModel.poiCover isEqualToString:@" "]) {
            finalCount=40+tempModel.poiTrafficArray.count*40;
        }else{
         finalCount=100+(UIScreen_Width-80)*0.62+tempModel.poiTrafficArray.count*40;
        }
    }
    return finalCount;
}


-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (tableView==self.hyTableview) {
        NSLog(@"点击的是整体的视图");
    }else{
        NSLog(@"点击的是交通的视图");
    }
    
}




#pragma mark－－－－－－－－－－－－－－－用户交互





- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
 #pragma mark - Navigation
 
 // In a storyboard-based application, you will often want to do a little preparation before navigation
 - (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
 // Get the new view controller using [segue destinationViewController].
 // Pass the selected object to the new view controller.
 }
 */

@end
